'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _server = require('react-dom/server');

var _AsyncRenderer = require('../components/AsyncRenderer');

var _AsyncRenderer2 = _interopRequireDefault(_AsyncRenderer);

var _removeDuplicateModules = require('../utils/removeDuplicateModules');

var _removeDuplicateModules2 = _interopRequireDefault(_removeDuplicateModules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var renderPass = function renderPass(context, element) {
  context.callback = function () {
    if (context.finishedLoadingModules && !context.statesRenderPass) {
      context.statesRenderPass = true;
      context.renderResult = renderPass(context, element);
      if (context.fetchingStates <= 0 && context.modulesLoading <= 0) {
        context.resolve({
          html: context.renderResult,
          state: context.fetchStateResults === undefined ? null : context.fetchStateResults,
          modules: context.modules === undefined ? null : (0, _removeDuplicateModules2.default)(context.modules)
        });
      }
    } else if (context.finishedLoadingModules && context.statesRenderPass) {
      context.renderResult = renderPass(context, element);
      if (context.fetchingStates <= 0 && context.modulesLoading <= 0) {
        context.resolve({
          html: context.renderResult,
          state: context.fetchStateResults === undefined ? null : context.fetchStateResults,
          modules: context.modules === undefined ? null : (0, _removeDuplicateModules2.default)(context.modules)
        });
      }
    }
  };

  var result = (0, _server.renderToString)(React.createElement(
    _AsyncRenderer2.default,
    { context: context },
    element
  ));

  if (!context.hasModules && !context.hasStates) {
    context.resolve({
      html: result,
      state: context.fetchStateResults === undefined ? null : context.fetchStateResults,
      modules: context.modules === undefined ? null : (0, _removeDuplicateModules2.default)(context.modules)
    });
  }
  return result;
};

exports.default = function (element) {
  return new Promise(function (resolve, reject) {
    var context = {
      resolve: resolve, reject: reject,
      modulesLoading: 0,
      fetchingStates: 0
    };
    renderPass(context, element);
  });
};