'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _validateStats = require('../utils/validateStats');

var _validateStats2 = _interopRequireDefault(_validateStats);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parse(module) {
  return {
    id: module.id,
    files: module.files
  };
}

function extractModule(module, stats) {
  if (module.info.type === 'webpack') {
    var match = stats.chunks.find(function (chunk) {
      return module.info.id == chunk.id;
    });
    return match ? parse(match) : match;
  }
}

exports.default = function (modules, stats) {
  (0, _validateStats2.default)(stats);
  if (modules && Object.prototype.toString.call(modules) === '[object Array]') {
    return modules.map(function (module) {
      return extractModule(module, stats);
    });
  }
  return [];
};